diff -r 82fcd4bea972 src/mipv6.h
--- a/src/mipv6.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mipv6.h	Fri Jan 11 17:02:25 2008 +0100
@@ -23,6 +23,7 @@
 /* Constants below have no explicit names in the spec. */
 
 #define MAX_BINDING_LIFETIME     (0xffff << 2) /* seconds */  
+#define MCOA_NO_BID		 0   /* BID is null */
 
 /* Maximum time for a binding to be unused for CN to still send a BRR
  * before the binding expires */
diff -r 82fcd4bea972 src/mn.c
--- a/src/mn.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mn.c	Fri Jan 11 17:02:25 2008 +0100
@@ -35,6 +35,8 @@
 #include <errno.h>
 #include <time.h>
 #include <unistd.h> 
+#include <sys/types.h>
+#include <signal.h>
 
 #include <netinet/icmp6.h>
 #include <netinet/ip6mh.h>
@@ -94,10 +96,44 @@ const struct timespec min_valid_bu_lifet
 const struct timespec min_valid_bu_lifetime_ts =
 { MIN_VALID_BU_LIFETIME, 0 };
 
+struct flag_hoa_args {
+	struct home_addr_info *target;
+	struct bulentry *bule;
+	int flag;
+};
+
 static int pending_bas = 0;
 
 static void mn_send_home_bu(struct home_addr_info *hai);
 static int mn_ext_tunnel_ops(int request, int old_if, int new_if, void *data);
+static int flag_hoa(struct ifaddrmsg *ifa, struct rtattr *rta_tb[], void *arg);
+static int mcoa_iface_rules_add(int iif, struct home_addr_info *hai);
+static struct bulentry* mcoa_iface_rules_del(int iif, 
+			struct home_addr_info *hai,
+			int replace);
+static void mcoa_mn_rules_del(struct home_addr_info *hinfo);
+static int nemo_mr_rules_add(struct home_addr_info *hinfo);
+static void nemo_mr_rules_del(struct home_addr_info *hinfo);
+
+static int mcoa_mn_init_rt_table(struct bulentry *bule)
+{
+	/* MCoA TODO2
+	 * At the moment, the routing table number 
+	 * is the BID number. BID must be between 
+	 * BCE_TABLE_MIN and BCE_TABLE_MAX
+	 */
+	assert(bule);
+
+	/* If BID is not assigned, default table is taken */
+	if (!bule->bid)
+		return (bule->table = RT6_TABLE_MIP6);
+	
+	if (bule->bid >= BULE_TABLE_MIN && bule->bid <= BULE_TABLE_MAX)
+		return (bule->table = bule->bid);
+
+	MDBG("Routing Table index is out of range");
+	return -1;
+}
 
 static int mn_block_rule_del(struct home_addr_info *hai)
 {
@@ -108,9 +144,9 @@ static int mn_block_rule_del(struct home
 		return ret;
 	}
 
-	if ((ret = rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK, RTN_BLACKHOLE,
-		     &hai->hoa.addr, 128, &in6addr_any, 0,
-		     FIB_RULE_FIND_SADDR)) < 0)
+	if ((ret = rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK, 0, 
+		     RTN_BLACKHOLE, &hai->hoa.addr, 128, &in6addr_any, 
+		     0, FIB_RULE_FIND_SADDR)) < 0)
 		MDBG("failed to delete blackhole rule.\n");
 	else
 		hai->home_block &= ~HOME_ADDR_RULE_BLOCK;
@@ -126,9 +162,9 @@ static int mn_block_rule_add(struct home
 		MDBG("blackhole is already set.\n");
 		return ret;
 	}
-	if ((ret = rule_add(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK, RTN_BLACKHOLE,
-		     &hai->hoa.addr, 128, &in6addr_any, 0,
-		     FIB_RULE_FIND_SADDR)) < 0)
+ 	if ((ret = rule_add(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK, 
+ 			    0, RTN_BLACKHOLE, &hai->hoa.addr, 128, 
+ 			    &in6addr_any, 0, FIB_RULE_FIND_SADDR)) < 0)
 		MDBG("failed to add blackhole rule.\n");
 	else
 		hai->home_block |= HOME_ADDR_RULE_BLOCK;
@@ -156,7 +192,10 @@ static void bule_invalidate(struct bulen
 	struct home_addr_info *hai = e->home;
 	struct in6_addr hoa, peer_addr;
 	int type = e->type;
+	int rules = e->rules;
+	int if_coa = e->if_coa;
 	uint16_t flags = e->flags;
+	uint16_t bid = e->bid;
 
 	if (type != BUL_ENTRY) 
 		return;
@@ -173,7 +212,7 @@ static void bule_invalidate(struct bulen
 	if (hai->at_home)
 		return;
 
-	e = create_bule(&hoa, &peer_addr);
+	e = create_bule(&hoa, &peer_addr, hai->reg_mcoa?bid:0);
 
 	if (e == NULL)
 		return;
@@ -185,6 +224,19 @@ static void bule_invalidate(struct bulen
 	e->lifetime = NON_MIP_CN_LTIME_TS;
 	e->delay = NON_MIP_CN_LTIME_TS;
 	e->callback = bul_expire;
+	e->priority = get_prio_from_bid(e->bid);
+	e->mcoa_dereg = 0;
+	/* MCoA: No tunnels are linked to this BULE anymore */
+	e->if_tunnel = 0;
+	/* MCoA: We prevent MIPL to install rules for this entry */
+	e->rules = 1;
+	mcoa_mn_init_rt_table(e);
+
+	/* MCoA: Erase rules corresponding to this BULE */
+	/* TODO2: this should be done when bul is deleted */
+	if(hai->reg_mcoa && rules)
+		mcoa_iface_rules_del(if_coa, hai, 1);
+
 	if (bul_add(e) < 0)
 		bul_delete(e);
 }
@@ -279,7 +331,10 @@ static void mn_recv_param_prob(const str
 	pthread_rwlock_wrlock(&mn_lock);
 	if (mn_rr_error_check(laddr, raddr, &addr))
 		laddr = &addr;
-	e = bul_get(NULL, laddr, raddr);
+	/* MCoA TODO1
+	 * All bule with same laddr, raddr should be invalidated
+	 */
+	e = bul_get(NULL, laddr, raddr, get_bid_from_ifindex(iif));
 	if (e != NULL) { 
 		if (e->flags & IP6_MH_BU_HOME) {
 			if (!conf.UseMnHaIPsec &&
@@ -328,6 +383,19 @@ static int mn_send_bu_msg(struct bulentr
 	}
 	if (bule->flags & IP6_MH_BU_HOME) {
 		struct home_addr_info *hai = bule->home;
+		/* MCoA TODO1: to update according to latest draft
+		 * Binding Unique Identifier Option 
+		 * For deregistration, BUI option is sent only 
+		 * when some specific entry needs to be deleted.
+		 * If all entries are deleted, no need to send BUI
+		 */
+		if ((bu->ip6mhbu_lifetime || !bule->mcoa_dereg)
+		    && hai->reg_mcoa && bule->bid 
+		    && mh_create_opt_bid(&iov[iov_ind++], bule->bid, 
+					 bule->priority, 0) < 0) {
+			free_iov_data(iov, iov_ind);
+			return -ENOMEM;				
+		}
 		if (bule->flags & IP6_MH_BU_MR && bu->ip6mhbu_lifetime &&
 		    bule->home->mnp_count > 0 && conf.MobRtrUseExplicitMode &&
 		    mh_create_opt_mob_net_prefix(&iov[iov_ind++],
@@ -353,7 +421,29 @@ static int mn_send_bu_msg(struct bulentr
 	addrs.remote_coa = NULL;
 	addrs.bind_coa = &bule->coa;
 
+	/* MCoA
+	 * before sending BU, if !bule->rules then
+	 * add rule from HoA to HA in table bule->table
+	 * This to be able to send a BU if no rules are in 
+	 * the RPDB (eg. because of the Reliability option)
+	 */
+	if(bule->home->reg_mcoa && !bule->rules)
+		/* MCoA: Rule for HoA to HA from the MN */
+		rule_add(NULL, bule->table, 
+			IP6_RULE_PRIO_MIP6_HOA_OUT_MCOA, 0, RTN_UNICAST, 
+			&bule->home->hoa.addr, 128, &bule->peer_addr, 128, 
+			FIB_RULE_FIND_SADDR);
+
 	ret = mh_send(&addrs, iov, iov_ind, bind_key, bule->if_coa);
+	
+	/* MCoA 
+	 * Delete the previously installed rule 
+	 */
+	if(bule->home->reg_mcoa && !bule->rules)
+		rule_del(NULL, bule->table, 
+			IP6_RULE_PRIO_MIP6_HOA_OUT_MCOA, 0, RTN_UNICAST, 
+			&bule->home->hoa.addr, 128, &bule->peer_addr, 128, 
+			FIB_RULE_FIND_SADDR); 
 
 	if (ret <= 0)
 		MDBG("mh_send failed  ret: %d\n", ret);
@@ -363,15 +453,35 @@ static int mn_send_bu_msg(struct bulentr
 	return ret;
 }
 
+struct mn_addr *mcoa_get_current_coa(struct home_addr_info *hai, int iif)
+{
+	struct list_head *l;
+
+	if(!hai->reg_mcoa)
+		return hai->current_coa;
+
+	list_for_each(l, &hai->mcoa) {
+		struct mn_addr *coa_entry;
+		coa_entry = list_entry(l, struct mn_addr, list);
+		if (coa_entry->iif == iif) 
+			return coa_entry;
+	}
+
+	return NULL;
+}
+
 static int mn_get_home_lifetime(struct home_addr_info *hai,
-				struct timespec *lifetime, int dereg)
+				struct timespec *lifetime, 
+				int iif, int dereg)
 {
 	if (!hai->at_home && !dereg) {
-		struct mn_addr *coa = &hai->primary_coa;
+		/* MCoA: Pick up the CoA from the correct iface */
+		struct mn_addr *coa = mcoa_get_current_coa(hai, iif);
 		struct timespec now;
 		unsigned long coa_lft;
 		unsigned long hoa_lft;
 
+		assert(coa);
 		clock_gettime(CLOCK_REALTIME, &now);		
 
 		coa_lft = mpd_curr_lft(&now, &coa->timestamp,
@@ -403,16 +513,20 @@ static int mn_get_ro_lifetime(struct hom
 	if (!hai->at_home && !dereg) {
 		struct bulentry *e;
 
-		e = bul_get(hai, NULL, &hai->ha_addr);
+		e = bul_get(hai, NULL, &hai->ha_addr, 
+			    hai->reg_mcoa?
+			    get_bid_from_ifindex(hai->current_coa->iif)
+			    :MCOA_NO_BID);
 
 		if (e == NULL || !(e->flags & IP6_MH_BU_HOME)) {
 			MDBG("No valid home registration");
 		} else {
 			struct timespec now;
-			struct mn_addr *coa = &hai->primary_coa;
+			struct mn_addr *coa = hai->current_coa;
 			unsigned long coa_lft;
 			unsigned long home_lft;
 
+			assert(coa);
 			clock_gettime(CLOCK_REALTIME, &now);		
 
 			coa_lft = mpd_curr_lft(&now, &coa->timestamp,
@@ -432,6 +546,21 @@ static int mn_get_ro_lifetime(struct hom
 	return 1;
 }
 
+/* MCoA
+ * Deregister a specific bule
+ */
+static int mn_dereg_bule(struct bulentry *bule)
+{
+	if (bule->type != NON_MIP_CN_ENTRY) {
+		bule->seq++;
+		bule->mcoa_dereg = 0;
+		tsclear(bule->lifetime);
+		mn_send_bu_msg(bule);
+	}
+	bul_delete(bule);
+	return 0;
+}
+
 static int mn_dereg(void *vbule, void *arg)
 {
 	struct bulentry *bule = vbule;
@@ -445,7 +574,20 @@ static int mn_dereg(void *vbule, void *a
 		}
 		bule->seq++;
 		tsclear(bule->lifetime);
-		mn_send_bu_msg(bule);
+		/* MCoA
+	 	 * When a MN wants to deregister Multiple CoA,
+	 	 * one BU is enough to deregister all the CoA
+		 */
+		if(bule->home->reg_mcoa && bule->mcoa_dereg) {	
+			mn_send_bu_msg(bule);
+			/* MCoA
+			 * Flag the other entries that match the
+			 * peer address (to avoid sending multiple
+			 * BUs)
+			 */
+			mcoa_bule_dereg(bule, 0);
+		} else if (!bule->home->reg_mcoa)
+			mn_send_bu_msg(bule);
 	}
 	bul_delete(bule);
 	return 0;
@@ -486,8 +628,9 @@ static int bu_lft_check(struct bulentry 
 	int dereg;
 
 	if (bule->flags & IP6_MH_BU_HOME)
-		dereg = mn_get_home_lifetime(bule->home, &bule->lifetime, 0);
-	else
+		dereg = mn_get_home_lifetime(bule->home, &bule->lifetime, 
+					     bule->if_coa, 0);
+ 	else
 		dereg = mn_get_ro_lifetime(bule->home, &bule->lifetime,
 					   bule->dereg);
 
@@ -544,6 +687,7 @@ static void bu_refresh(struct tq_elem *t
 	if (!task_interrupted()) {
 		struct bulentry *bule = tq_data(tqe, struct bulentry, tqe);
 		int expired;
+		int iif = bule->if_coa;
 		MDBG("Bul refresh type: %d\n", bule->type);
 
 		clock_gettime(CLOCK_REALTIME, &bule->lastsent);
@@ -554,6 +698,10 @@ static void bu_refresh(struct tq_elem *t
 
 		bule->seq++;
 		bule->callback = bu_resend;
+		/* MCoA : Check for interface reliability */
+		if(bule->home->reg_mcoa 
+		   && get_reliable_from_ifindex(iif) == 0)
+			mcoa_iface_rules_del(iif, bule->home, 1);
 		pre_bu_bul_update(bule);
 		mn_send_bu_msg(bule);
 
@@ -626,14 +774,53 @@ static int mv_hoa(struct ifaddrmsg *ifa,
 	return 0;
 }
 
-int nemo_mr_tnl_routes_add(struct home_addr_info *hai, int ifindex)
+/*
+ * Copy home address between two interfaces
+ */
+static int cp_hoa(struct ifaddrmsg *ifa, struct rtattr *rta_tb[], void *arg)
+{
+	struct mv_hoa_args *mha = arg;
+	struct home_addr_info *hai = mha->target;
+	struct mn_addr *hoa = &hai->hoa;
+	int err;
+	struct timespec now;
+	uint32_t preferred = PREFIX_LIFETIME_INFINITE;
+	uint32_t valid = PREFIX_LIFETIME_INFINITE;
+	int plen = (mha->if_next == hai->if_tunnel ? 128 : hai->plen);
+
+	clock_gettime(CLOCK_REALTIME, &now);
+
+	if (hai->lladdr_comp && rta_tb[IFA_CACHEINFO] != NULL) {
+		struct ifa_cacheinfo *ci = RTA_DATA(rta_tb[IFA_CACHEINFO]);
+		mn_update_hoa_lifetime(hoa, &now, 
+				       ci->ifa_valid, ci->ifa_prefered);
+		valid = ci->ifa_valid;
+		preferred = ci->ifa_prefered;
+	}
+	if (mha->if_next == ifa->ifa_index)
+		return 0;
+
+	MDBG("Copy HoA %x:%x:%x:%x:%x:%x:%x:%x/%d from iface %d to %d\n",
+	     NIP6ADDR(&hoa->addr), plen, ifa->ifa_index, mha->if_next);
+
+	err = addr_add(&hoa->addr, plen,
+		       ifa->ifa_flags|IFA_F_HOMEADDRESS,
+		       ifa->ifa_scope, mha->if_next, preferred, valid);
+	if (err < 0)
+		return err;
+
+	return 0;
+}
+
+int nemo_mr_tnl_routes_add(struct home_addr_info *hai,
+			   int ifindex, int rtable)
 {
 	struct list_head *l;
 	struct prefix_list_entry *pe;
 	list_for_each(l, &hai->mob_net_prefixes) {
 		struct prefix_list_entry *p;
 		p = list_entry(l, struct prefix_list_entry, list);
-		if (route_add(ifindex, RT6_TABLE_MIP6, RTPROT_MIP,
+ 		if (route_add(ifindex, rtable, RTPROT_MIP,
 			      0, IP6_RT_PRIO_MIP6_FWD,
 			      &p->ple_prefix, p->ple_plen,
 			      &in6addr_any, 0, NULL) < 0) {
@@ -646,7 +833,7 @@ undo:
 	list_for_each(l, &hai->mob_net_prefixes) {
 		struct prefix_list_entry *p;
 		p = list_entry(l, struct prefix_list_entry, list);
-		route_del(ifindex, RT6_TABLE_MIP6, IP6_RT_PRIO_MIP6_FWD,
+ 		route_del(ifindex, rtable, IP6_RT_PRIO_MIP6_FWD, 
 			  &p->ple_prefix, p->ple_plen, &in6addr_any, 0, NULL);
 		if (p == pe)
 			break;
@@ -654,44 +841,47 @@ undo:
 	return -1;
 }
 
-static int mn_tnl_state_add(struct home_addr_info *hai, int ifindex, int all)
+static int mn_tnl_state_add(struct home_addr_info *hai, 
+			    int ifindex, int all, int rtable)
 {
 	int err = 0;
 	if (hai->home_reg_status != HOME_REG_NONE) {
 		if ((err = mn_ro_pol_add(hai, ifindex, all)) < 0)
 			return err;
-		if ((err = route_add(ifindex, RT6_TABLE_MIP6, RTPROT_MIP, 0,
+		if ((err = route_add(ifindex, rtable, RTPROT_MIP, 0,
 				     IP6_RT_PRIO_MIP6_OUT, &in6addr_any, 0,
 				     &in6addr_any, 0, NULL)) < 0) {
 			mn_ro_pol_del(hai, ifindex, all);
 		}
 	}
 	if (hai->mob_rtr &&
-	    (err = nemo_mr_tnl_routes_add(hai, ifindex)) < 0) {
-		route_del(ifindex, RT6_TABLE_MIP6, IP6_RT_PRIO_MIP6_OUT,
+	    (err = nemo_mr_tnl_routes_add(hai, ifindex, rtable)) < 0) {
+		route_del(ifindex, rtable, IP6_RT_PRIO_MIP6_OUT, 
 			  &hai->hoa.addr, 128, &in6addr_any, 0, NULL);
 		mn_ro_pol_del(hai, ifindex, all);
 	}
 	return err;
 }
 
-static void nemo_mr_tnl_routes_del(struct home_addr_info *hai, int ifindex)
+static void nemo_mr_tnl_routes_del(struct home_addr_info *hai, 
+				   int ifindex, int rtable)
 {
 	struct list_head *l;
 	list_for_each(l, &hai->mob_net_prefixes) {
 		struct prefix_list_entry *p;
 		p = list_entry(l, struct prefix_list_entry, list);
-		route_del(ifindex, RT6_TABLE_MIP6, IP6_RT_PRIO_MIP6_FWD,
+		route_del(ifindex, rtable, IP6_RT_PRIO_MIP6_FWD, 
 			  &p->ple_prefix, p->ple_plen, &in6addr_any, 0, NULL);
 	}
 }
 
-static void mn_tnl_state_del(struct home_addr_info *hai, int ifindex, int all)
+static void mn_tnl_state_del(struct home_addr_info *hai, int ifindex, 
+			     int all, int rtable)
 {
 	if (hai->home_reg_status != HOME_REG_NONE) {
 		if (hai->mob_rtr)
-			nemo_mr_tnl_routes_del(hai, ifindex);
-		route_del(ifindex, RT6_TABLE_MIP6, IP6_RT_PRIO_MIP6_OUT, 
+			nemo_mr_tnl_routes_del(hai, ifindex, rtable);
+		route_del(ifindex, rtable, IP6_RT_PRIO_MIP6_OUT, 
 			  &hai->hoa.addr, 128, &in6addr_any, 0, NULL);
 		mn_ro_pol_del(hai, ifindex, all);
 	}
@@ -715,8 +905,18 @@ static void mn_pol_ext_cleanup(struct bu
 static void mn_pol_ext_cleanup(struct bulentry *bule)
 {
 	MDBG("\n");
-	mpd_cancel_mps(&bule->hoa, &bule->peer_addr);
-	mn_tnl_state_del(bule->home, bule->home->if_tunnel, 0);
+	/* MCoA
+	 * MPS is canceled only if the BULE is the last entry 
+	 * for the HoA, or when at home
+	 */
+	if (mcoa_bule_count(bule) == 0 || bule->home->at_home)
+		mpd_cancel_mps(&bule->hoa, &bule->peer_addr);
+	if (bule->home->reg_mcoa)
+		mn_tnl_state_del(bule->home, bule->if_tunnel, 0, 
+				 bule->table);
+	else
+		mn_tnl_state_del(bule->home, bule->home->if_tunnel, 
+				 0, bule->table);
 
 	if (conf.UseMnHaIPsec) {
 		mn_ipsec_tnl_update(&bule->peer_addr, &bule->hoa, bule);
@@ -730,12 +930,13 @@ static int process_first_home_bu(struct 
 				 struct timespec *lifetime)
 {
 	int err = 0;
+	assert(hai->current_coa);
 	bule->type = BUL_ENTRY;
 	bule->flags = (IP6_MH_BU_HOME | IP6_MH_BU_ACK |
 		       hai->lladdr_comp | hai->mob_rtr);
 	bule->coa_changed = -1;
-	bule->coa = hai->primary_coa.addr;
-	bule->if_coa = hai->primary_coa.iif;
+	bule->coa = hai->current_coa->addr;
+	bule->if_coa = hai->current_coa->iif;
 	bule->lifetime = *lifetime;
 	bule->delay = conf.InitialBindackTimeoutFirstReg_ts;
 	bule->callback = bu_resend;
@@ -744,10 +945,47 @@ static int process_first_home_bu(struct 
 	bule->ext_cleanup = mn_pol_ext_cleanup;
 	bule->home = hai;
 	bule->consecutive_resends = 0;
+	bule->priority = get_prio_from_bid(bule->bid);
 
 	hai->home_reg_status = HOME_REG_UNCERTAIN;
 
-	if ((err = mn_tnl_state_add(hai, hai->if_tunnel, 0)) < 0)
+	/* MCoA: MCoA requires one tunnel per CoA. Need to create a new one */
+	if (bule->if_tunnel == 0 
+	    && hai->reg_mcoa 
+	    && get_bid_from_ifindex(hai->current_coa->iif)) {
+		MDBG("Creating new tunnel for iface %d (BID %d)\n", 
+			hai->current_coa->iif, 
+			get_bid_from_ifindex(hai->current_coa->iif)); 
+		bule->if_tunnel = tunnel_add(&hai->hoa.addr, 
+					&hai->ha_addr,
+					hai->current_coa->iif, 
+					NULL, NULL);
+		if (bule->if_tunnel <= 0) {
+			MDBG("Failed to create MN-HA tunnel\n"); 
+			return -1;
+		} else {
+			MDBG("MN-HA tunnel created (iface tnl = %d)\n", 
+				bule->if_tunnel);
+			struct flag_hoa_args arg;
+			arg.target = hai;
+			arg.flag = 1;
+			arg.bule = bule;
+			if (addr_do(&hai->hoa.addr, 128,
+				    bule->if_tunnel, &arg, 
+				    flag_hoa) < 0) {
+				MDBG("addr_do failed for tunnel %d\n", 
+					bule->if_tunnel);
+				return -1;
+			}
+		}
+	} else if (bule->if_tunnel == 0)
+		/* MCoA
+		 * If MCoA is not used, then initialise the tunnel 
+		 * number to the one in hai
+		 */
+		bule->if_tunnel = hai->if_tunnel;
+		
+	if ((err = mn_tnl_state_add(hai, bule->if_tunnel, 0, bule->table)) < 0)
 		MDBG("Failed to initialize new bule for HA\n");
 	else
 		MDBG("New bule for HA\n");
@@ -781,14 +1019,18 @@ static void mn_send_home_bu(struct home_
 	movement_t type_movement = MIP6_TYPE_MOVEMENT_UNKNOWN;
 
 	TRACE;
+	assert(hai->current_coa);
 
 	if (IN6_IS_ADDR_UNSPECIFIED(&hai->ha_addr)) {
 		MDBG("HA not set for home link\n");
 		return;
 	}
-	mn_get_home_lifetime(hai, &lifetime, 0);
+	mn_get_home_lifetime(hai, &lifetime, hai->current_coa->iif, 0);
 
-	if ((bule = bul_get(hai, NULL, &hai->ha_addr)) == NULL) {
+	if ((bule = bul_get(hai, NULL, &hai->ha_addr, 
+			hai->reg_mcoa?
+			get_bid_from_ifindex(hai->current_coa->iif)
+			:MCOA_NO_BID)) == NULL) {
 		assert(!hai->at_home);
 		/* Create new bul entry for HA */
 		if (!tsisset(lifetime)) {
@@ -807,14 +1049,22 @@ static void mn_send_home_bu(struct home_
 				mn_change_ha(hai);
 			return;
 		}
-		bule = create_bule(&hai->hoa.addr, &hai->ha_addr);
+		bule = create_bule(&hai->hoa.addr, &hai->ha_addr,
+				hai->reg_mcoa?
+				get_bid_from_ifindex(hai->current_coa->iif)
+				:MCOA_NO_BID);
 		if (bule == NULL)
 			return;
-		if (process_first_home_bu(bule, hai, &lifetime) < 0 ||
+		if (mcoa_mn_init_rt_table(bule) < 0 ||
+		    process_first_home_bu(bule, hai, &lifetime) < 0 ||
 		    bul_add(bule) < 0) {
 			bul_delete(bule);
 			return;
 		}
+		/* MCoA: Check for interface reliability */
+		if(get_reliable_from_ifindex(bule->if_coa) > 0)
+			/* MCoA: Add the rules */
+			mcoa_iface_rules_add(hai->current_coa->iif, hai);
 		type_movement = MIP6_TYPE_MOVEMENT_HL2FL;
 		MDBG("New bule for HA\n");
 	} else if (bule->type == BUL_ENTRY) {
@@ -829,8 +1079,8 @@ static void mn_send_home_bu(struct home_
 			}
 			type_movement = MIP6_TYPE_MOVEMENT_HL2FL;
 		} else {
-			bule->coa = hai->primary_coa.addr;
-			bule->if_coa = hai->primary_coa.iif;
+			bule->coa = hai->current_coa->addr;
+			bule->if_coa = hai->current_coa->iif;
 
 			/* Rate limiting home registration binding updates
 			   is necessary for multihomed MNs */
@@ -850,6 +1100,10 @@ static void mn_send_home_bu(struct home_
 			bule->callback = bu_resend;
 		}
 		bule->seq++;
+		/* MCoA: Check for interface reliability */
+		if(bule->home->reg_mcoa 
+		   && get_reliable_from_ifindex(bule->if_coa) == 0)
+			mcoa_iface_rules_del(bule->if_coa, bule->home, 1); 
 		pre_bu_bul_update(bule);
 		MDBG("Bule for HA exists. Updating it.\n");
 	} else {
@@ -885,10 +1139,13 @@ static void mn_send_home_bu(struct home_
 					    &bule->hoa, bule);
 		}
         }
+	/* MCoA: Update the current routing table */
+	hai->table = bule->table;
 	/* Before bul_iterate, tunnel modification should be done. */
-	tunnel_mod(hai->if_tunnel, &hai->primary_coa.addr, &hai->ha_addr,
-		   hai->primary_coa.iif, mn_ext_tunnel_ops, hai);
-		
+	bule->if_tunnel = tunnel_mod(bule->if_tunnel, &hai->current_coa->addr, 
+				     &hai->ha_addr, hai->current_coa->iif, 
+				     mn_ext_tunnel_ops, hai);
+	hai->if_tunnel = bule->if_tunnel;		
 	bule->last_coa = bule->coa;
 	bule->coa_changed = 0;
 
@@ -1017,14 +1274,87 @@ static int mn_chk_bauth(struct ip6_mh_bi
 	return -1;
 }
 
+static int mn_disable_mcoa(struct bulentry *bule)
+{
+/*
+	struct bulentry *bule_del;
+	struct home_addr_info *hai;
+	struct flag_hoa_args arg;
+	struct list_head *l, *tmp;
+	struct net_iface *best_iface = NULL;
+*/
+
+	/* MCoA TODO1: At the moment we simply exit */
+	MDBG("HA does not accept MCoA registration. Check "\
+	     "your HA or change your MR configuration\n");
+	kill(0, SIGINT);
+	return 0;
+
+/*
+	assert(bule);
+	hai = bule->home;
+	mcoa_mn_rules_del(hai);
+        while((bule_del = bul_get(hai, NULL, 
+				&bule->peer_addr, MCOA_NO_BID)))
+		bul_delete(bule_del);
+	
+	hai->if_tunnel = tunnel_add(&hai->hoa.addr, &hai->ha_addr,
+				    hai->if_home, NULL, NULL);
+	if (hai->if_tunnel <= 0) {
+		MDBG("failed to create MN-HA tunnel\n"); 
+		goto clean_err;
+	}
+
+	arg.target = hai;
+	arg.flag = 1;
+	if (addr_do(&hai->hoa.addr, 128, hai->if_tunnel, 
+		    &arg, flag_hoa) < 0)
+		goto clean_err;
+
+	nemo_mr_rules_del(hai);
+	hai->reg_mcoa = 0;
+	nemo_mr_rules_add(hai);
+	if (rule_add(NULL, RT6_TABLE_MIP6, IP6_RULE_PRIO_MIP6_HOA_OUT, 0, 
+			RTN_UNICAST, &hai->hoa.addr, 
+			128, &in6addr_any, 0, FIB_RULE_FIND_SADDR) < 0)
+		goto clean_err;
+
+	list_for_each(l, &conf.net_ifaces) {
+		struct net_iface *iface = NULL;
+		iface = list_entry(l, struct net_iface, list);
+		if (!best_iface 
+		    || iface->mn_if_bidprio > best_iface->mn_if_bidprio)
+			best_iface = iface;
+	}
+	list_for_each_safe(l, tmp, &conf.net_ifaces) {
+		struct net_iface *iface = NULL;
+		iface = list_entry(l, struct net_iface, list);
+		if (iface != best_iface) {
+			MDBG("Deleting iface %d\n", iface->ifindex);
+			list_del(l);
+		}
+	}
+	return 1;
+	
+clean_err:
+	rule_del(NULL, RT6_TABLE_MIP6, 
+		IP6_RULE_PRIO_MIP6_HOA_OUT, 0, RTN_UNICAST, 
+		&hai->hoa.addr, 128, &in6addr_any, 0, FIB_RULE_FIND_SADDR);
+	tunnel_del(hai->if_tunnel, NULL, NULL);
+
+	return 0;
+*/
+}
+
 static void mn_recv_ba(const struct ip6_mh *mh, ssize_t len,
 		       const struct in6_addr_bundle *in, int iif)
 {
 	struct ip6_mh_binding_ack *ba;
+	struct ip6_mh_opt_bid *bui;
 	struct mh_options mh_opts;
 	struct bulentry *bule;
 	struct timespec now, ba_lifetime, br_adv;
-	uint16_t seqno;
+	uint16_t seqno, bid;
 
 	TRACE;
 
@@ -1036,25 +1366,32 @@ static void mn_recv_ba(const struct ip6_
 	ba = (struct ip6_mh_binding_ack *)mh;
 
 	pthread_rwlock_wrlock(&mn_lock);
-	bule = bul_get(NULL, in->dst, in->src);
+
+	/* MCoA: Lookup in BA options for the BUI sub-option and the BID */
+	bui = mh_opt(&ba->ip6mhba_hdr, &mh_opts, IP6_MHOPT_BID);
+	bid = bui ? ntohs(bui->ip6mobid_bid) : MCOA_NO_BID;
+	
+	bule = bul_get(NULL, in->dst, in->src, bid);
 	if (!bule || bule->type != BUL_ENTRY) {
 		MDBG("Got BA without corresponding BUL entry "
 		     "from %x:%x:%x:%x:%x:%x:%x:%x "
 		     "to home address %x:%x:%x:%x:%x:%x:%x:%x "
-		     "with coa %x:%x:%x:%x:%x:%x:%x:%x\n",
+		     "with coa %x:%x:%x:%x:%x:%x:%x:%x"
+		     "and bid %d\n",
 		     NIP6ADDR(in->src),  
 		     NIP6ADDR(in->dst),
 		     NIP6ADDR(in->local_coa != NULL ? 
-			      in->local_coa : &in6addr_any));
+			      in->local_coa : &in6addr_any),
+		     bid);
 		pthread_rwlock_unlock(&mn_lock);
 		return;
 	}
 	dbg("Got BA from %x:%x:%x:%x:%x:%x:%x:%x "
 	    "to home address %x:%x:%x:%x:%x:%x:%x:%x "
-	    "with coa %x:%x:%x:%x:%x:%x:%x:%x and status %d\n",
+	    "with coa %x:%x:%x:%x:%x:%x:%x:%x, bid %d and status %d\n",
 	    NIP6ADDR(in->src), NIP6ADDR(in->dst),
 	    NIP6ADDR(in->local_coa != NULL ? in->local_coa : &in6addr_any),
-	    ba->ip6mhba_status);
+	    bid, ba->ip6mhba_status);
 	dbg("Dumping corresponding BULE\n");
 	dbg_func(bule, dump_bule);
 	/* First check authenticator */
@@ -1076,6 +1413,17 @@ static void mn_recv_ba(const struct ip6_
 			return;
 		}
 	}
+	/* MCoA: Check if BID matches */
+	if (bule->bid && !bui) {
+		/* The BACK did not have any BID suboption whereas 
+		 * we sent a BU with a BID option. MCoA is disabled 
+		 * on the node.
+		 */
+		MDBG("Got BA with no BID option, disabling MCoA registration.\n");
+		mn_disable_mcoa(bule);
+		pthread_rwlock_unlock(&mn_lock);
+		return;
+	}
 	bule->do_send_bu = 0;
 	bule->consecutive_resends = 0;
 	clock_gettime(CLOCK_REALTIME, &now);
@@ -1086,11 +1434,18 @@ static void mn_recv_ba(const struct ip6_
 			bule->seq = seqno + 1;
 			if (bule->flags & IP6_MH_BU_HOME)
 				mn_get_home_lifetime(bule->home,
-						     &bule->lifetime, 0);
+						     &bule->lifetime, 
+						     bule->if_coa,
+						     0);
 			else
 				mn_get_ro_lifetime(bule->home,
 						   &bule->lifetime, 0);
 			bule->callback = bu_resend;
+			/* MCoA: Check for interface reliability */
+			if(bule->home->reg_mcoa 
+		   	   && get_reliable_from_ifindex(bule->if_coa) == 0)
+				mcoa_iface_rules_del(bule->if_coa, 
+						     bule->home, 1);
 			pre_bu_bul_update(bule);
 			mn_send_bu_msg(bule);
 			bule->delay = conf.InitialBindackTimeoutReReg_ts;
@@ -1137,6 +1492,10 @@ static void mn_recv_ba(const struct ip6_
 	tssetsec(ba_lifetime, ntohs(ba->ip6mhba_lifetime) << 2);
 	br_adv = ba_lifetime;
 	tsadd(bule->lastsent, ba_lifetime, bule->hard_expire);
+	/* MCoA: Check for interface reliability */
+	if(bule->home->reg_mcoa 
+	   && get_reliable_from_ifindex(bule->if_coa) == 0)
+		mcoa_iface_rules_add(bule->if_coa, bule->home); 
 	if (!(bule->flags & IP6_MH_BU_HOME) || !conf.OptimisticHandoff)
 		post_ba_bul_update(bule);
 	if (bule->flags & IP6_MH_BU_HOME) {
@@ -1266,11 +1625,6 @@ struct home_addr_info *mn_get_home_addr_
 	return NULL;
 }
 
-struct flag_hoa_args {
-	struct home_addr_info *target;
-	int flag;
-};
-
 static int flag_hoa(struct ifaddrmsg *ifa, struct rtattr *rta_tb[], void *arg)
 {
 	/*
@@ -1279,13 +1633,18 @@ static int flag_hoa(struct ifaddrmsg *if
 
 	struct flag_hoa_args *fhoa = arg;
 	struct home_addr_info *hai = fhoa->target;
+	struct bulentry *bule = fhoa->bule;
 	struct mn_addr *hoa = &hai->hoa;
 	struct in6_addr *addr = RTA_DATA(rta_tb[IFA_ADDRESS]);
 	struct timespec now;
 	uint32_t preferred;
 	uint32_t valid;
-	int err;
-	int plen = (ifa->ifa_index == hai->if_tunnel ? 128 : hai->plen);
+	int err, plen;
+
+	if (hai->reg_mcoa && bule != NULL)
+		plen = (ifa->ifa_index == bule->if_tunnel ? 128 : hai->plen);
+	else
+		plen = (ifa->ifa_index == hai->if_tunnel ? 128 : hai->plen);
 
 	clock_gettime(CLOCK_REALTIME, &now);
 
